<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJPSOAP_HotelInventorySpecialNotesNote ArrayType
 * @subpackage Arrays
 */
class ArrayOfJPSOAP_HotelInventorySpecialNotesNote extends AbstractStructArrayBase
{
    /**
     * The Note
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\Note[]
     */
    public $Note;
    /**
     * Constructor method for ArrayOfJPSOAP_HotelInventorySpecialNotesNote
     * @uses ArrayOfJPSOAP_HotelInventorySpecialNotesNote::setNote()
     * @param \StructType\Note[] $note
     */
    public function __construct(array $note = array())
    {
        $this
            ->setNote($note);
    }
    /**
     * Get Note value
     * @return \StructType\Note[]|null
     */
    public function getNote()
    {
        return $this->Note;
    }
    /**
     * Set Note value
     * @throws \InvalidArgumentException
     * @param \StructType\Note[] $note
     * @return \ArrayType\ArrayOfJPSOAP_HotelInventorySpecialNotesNote
     */
    public function setNote(array $note = array())
    {
        foreach ($note as $arrayOfJPSOAP_HotelInventorySpecialNotesNoteNoteItem) {
            // validation for constraint: itemType
            if (!$arrayOfJPSOAP_HotelInventorySpecialNotesNoteNoteItem instanceof \StructType\Note) {
                throw new \InvalidArgumentException(sprintf('The Note property can only contain items of \StructType\Note, "%s" given', is_object($arrayOfJPSOAP_HotelInventorySpecialNotesNoteNoteItem) ? get_class($arrayOfJPSOAP_HotelInventorySpecialNotesNoteNoteItem) : gettype($arrayOfJPSOAP_HotelInventorySpecialNotesNoteNoteItem)), __LINE__);
            }
        }
        $this->Note = $note;
        return $this;
    }
    /**
     * Add item to Note value
     * @throws \InvalidArgumentException
     * @param \StructType\Note $item
     * @return \ArrayType\ArrayOfJPSOAP_HotelInventorySpecialNotesNote
     */
    public function addToNote(\StructType\Note $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Note) {
            throw new \InvalidArgumentException(sprintf('The Note property can only contain items of \StructType\Note, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Note[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Note|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Note|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Note|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Note|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Note|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Note
     */
    public function getAttributeName()
    {
        return 'Note';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJPSOAP_HotelInventorySpecialNotesNote
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
